<?php

namespace Aviatoo\Rest\Service;

use Aviatoo\Rest\ORM\QueryBuilder;
use Aviatoo\Rest\Repository\EntityRepository;
use Aviatoo\Rest\Repository\Pagination;
use Doctrine\DBAL\Exception\ForeignKeyConstraintViolationException;
use Doctrine\DBAL\Exception\NotNullConstraintViolationException;
use Doctrine\DBAL\Exception\UniqueConstraintViolationException;
use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\DBAL\Driver\Connection;


/**
 * Class DoctrineApiManager
 * @package Aviatoo\Rest\Service
 */
class DoctrineApiManager
{
    const PAGE_SIZE=10;

    /**
     * @var EntityManagerInterface
     */
    private $entityManager;

    /**
     * @var Connection
     */
    private $nativeConnection;

    /**
     * DoctrineApiManager constructor.
     * @param EntityManagerInterface $entityManager
     */
    public function __construct(EntityManagerInterface $entityManager,Connection $connection)
    {
        $this->entityManager=$entityManager;
        $this->nativeConnection = $connection;
    }

    /**
     * @return \Doctrine\DBAL\Query\QueryBuilder
     */
    public function getNativeQueryBuilder(){
        return $this->nativeConnection->createQueryBuilder();
    }

    /**
     * @param $class
     * @param $alias
     * @return \Aviatoo\Rest\ORM\QueryBuilder|mixed
     */
    public function getQueryBuilder($class,$alias){
        $queryBuilder = $this->createQueryBuilder($class,$alias);
        $pagination = Pagination::getPagination();
        if($pagination) $queryBuilder = $queryBuilder->setPagination($pagination);
        return $queryBuilder;
    }

    /**
     * @param $class
     * @param $alias
     * @return QueryBuilder
     */
    private function createQueryBuilder($class,$alias){
        $repo = $this->getRepository($class);
        if($repo instanceof EntityRepository) return $repo->createQueryBuilder($alias);
        else {
            $qb = new QueryBuilder($this->entityManager);
            return $qb->select($alias)->from($class, $alias);
        }

    }

    /**
     * @param $entity
     */
    public function persist($entity)
    {
        $this->entityManager->persist($entity);
    }

    /**
     * @param $entityName
     * @return \Doctrine\Common\Persistence\ObjectRepository
     */
    public function getRepository($entityName)
    {
        return $this->entityManager->getRepository($entityName);
    }

    /**
     * @param null $entity
     * @throws \Aviatoo\Rest\Exception\ForeignKeyConstraintViolationException
     * @throws \Aviatoo\Rest\Exception\NotNullConstraintViolationException
     * @throws \Aviatoo\Rest\Exception\UniqueConstraintViolationException
     * @throws \Exception
     */
    public function flush($entity = null)
    {
        try{
            $this->entityManager->flush($entity);
        }catch (\Exception $exception){
            if($exception instanceof UniqueConstraintViolationException)
                throw new \Aviatoo\Rest\Exception\UniqueConstraintViolationException($exception);
            else if($exception instanceof ForeignKeyConstraintViolationException)
                throw new \Aviatoo\Rest\Exception\ForeignKeyConstraintViolationException($exception);
            else if($exception instanceof  NotNullConstraintViolationException)
                throw new \Aviatoo\Rest\Exception\NotNullConstraintViolationException($exception);
            else throw $exception;
        }

    }

    /**
     * @param $entity
     */
    public function remove($entity)
    {
        $this->entityManager->remove($entity);// TODO: Change the autogenerated stub
    }

}